<?php

class Mch_Editor_Headline_Jump {


	// <editor-fold desc="定数">
	const APP_PREFIX        = 'mch_ehj';
	const APP_TITLE         = 'Editor_Headline_Jump';
	const APP_LANG_DMN      = 'editor-headline-jump';

	// </editor-fold>


	// <editor-fold desc="util">

	/**
	 * 表示用テキスト
	 * @param string $text
	 * @return string
	 */
	public function _t($text){
		return $text;
	}

	/**
	 * add prefix text
	 * @param string $text
	 * @return string
	 */
	public function __ap($text){
		return $this->add_prefix($text);
	}
	/**
	 * add prefix text
	 * @param $text
	 * @return string
	 */
	private function add_prefix($text) {
		return self::APP_PREFIX . '_' . $text;
	}

	public static function get_object() {
		static $instance = null;
		if ( NULL === $instance ) {
			$instance = new self();
		}
		return $instance;
	}


	/**
	 * @param string $key
	 * @return string
	 */
	private function getPluginData($key){
		static $pluginData = null;

		if($pluginData === null){//
			$pluginData = get_file_data(MCH_EHJ_PLUGIN_DIR . 'mch-editor-headline-jump.php', [
				'version' => 'Version',
				'author' => 'Author',
			]);
		}

		if(isset($pluginData[$key])){
			return $pluginData[$key];
		} else {
			return '';
		}
	}


	// </editor-fold>

	public static function myplugin_load_textdomain() {
		load_plugin_textdomain( self::APP_LANG_DMN );
	}


	public function __construct(){
		if ( is_admin() ) {

			$v  = $this->getPluginData('version');

            // <editor-fold desc="テーマの編集">
            add_action('admin_print_styles',  [$this, 'my_admin_print_styles']);
            add_action('admin_print_scripts',  [$this, 'my_admin_print_scripts']);
            add_action('admin_print_styles-theme-editor.php', [$this, 'theme_editor_add_scripts']);
            add_action('admin_print_scripts-theme-editor.php', [$this, 'my_admin_print_scripts_theme']);

            add_action( 'add_meta_boxes', array ( $this, 'switch_boxes' ) );
            // </editor-fold>

			return;
		}
	}


	private function isEditorPage(){

		if(get_post_type() === 'page'){
			return true;
		}

		if(get_post_type() === 'post'){
			return true;
		}
        return false;
    }


	private $_test = '';

	function my_admin_print_styles() {
		if( !$this->isEditorPage() ){
			return;
		}
//		error_log(__FILE__ . '('.__LINE__.')['.__FUNCTION__.']');
	}
	function my_admin_print_scripts() {

		if( !$this->isEditorPage() ){
		    return;
		}


		$strList = array(
			'headline' =>  __( 'Headline',self::APP_LANG_DMN ),
			'close' =>  __( 'close',self::APP_LANG_DMN ),
        );


		echo '<script>var _mchEhjStr = {};';
		foreach ($strList as $key => $str){
		?>
        _mchEhjStr['<?php echo $key ?>'] = '<?php echo $str ?>';
		<?php
		}
		global $wp_version;



		$miniStr = ".min";
//		$miniStr = "";

//		echo 'console.log("======== my_admin_print_scripts");';
		echo '</script>';
		$wpVerDir = "5.6";
		if ( version_compare( $wp_version, $wpVerDir, '>=' ) ) {
			if ($miniStr) {
				$miniStr = "";
			} else {
				$miniStr = "gen-origin-files/";
			}

			wp_enqueue_script(
				'my-admin-script_com',
				plugin_dir_url( __FILE__ ). '/js/'.$wpVerDir."/{$miniStr}mch_ehj_com.js"
				, array( 'jquery')
				, null
			);
			wp_enqueue_script(
				'my-admin-script',
				plugin_dir_url( __FILE__ ). '/js/'.$wpVerDir."/{$miniStr}mch_ehj.js"
				, array( 'jquery')
				, null
			);

		} else {
			wp_enqueue_script(
				'my-admin-script_com',
//				plugin_dir_url( __FILE__ ). '/js/mch_ehj_com'.$miniStr.'.js'
				plugin_dir_url( __FILE__ ). '/js/mch_ehj_com.js'
				, array( 'jquery')
				, null
			);
			wp_enqueue_script(
				'my-admin-script',
//				plugin_dir_url( __FILE__ ). '/js/mch_ehj'.$miniStr.'.js'
				plugin_dir_url( __FILE__ ). '/js/mch_ehj.js'
				, array( 'jquery')
				, null
			);

		}
	}

	/**
	 * テーマの編集画面用追加JS
	 */
	function theme_editor_add_scripts(){
		if( !$this->isEditorPage() ){
			return;
		}

//		echo '<script>';
//		echo 'console.log("----- theme_editor_add_scripts");';
//		echo '</script>';
	}

	/**
	 * テーマの編集画面追加スクリプト
	 */
	function my_admin_print_scripts_theme() {
		if( !$this->isEditorPage() ){
			return;
		}


	}




//デフォルトの抜粋入力欄をビジュアルエディターにする
//add_action( 'add_meta_boxes', array ( 'VisualEditorExcerpt', 'switch_boxes' ) );
//if ( !class_exists( 'VisualEditorExcerpt' ) ):
//class VisualEditorExcerpt{
	public function switch_boxes()
	{
		if( !$this->isEditorPage() ){
			return;
		}

		add_meta_box(
			'postexcerpt2__'   // Reusing just 'postexcerpt' doesn't work.
			,   __( 'Headline',self::APP_LANG_DMN )  // タイトル
			,   array ( __CLASS__, 'show' ) // 表示関数
			,   null          // スクリーン
			,   'side'      // コンテキスト
			,   'default'        // 優先度
		);
	}


	//メタボックスの出力
	public static function show( $post )  {
	    $v = 1;
		$floatStr =  __('float',self::APP_LANG_DMN);
		wp_enqueue_style( 'mch-ehj-my-css', plugins_url( '/', __FILE__) . '/css/mch_ehj.css', array(), $v );
		?>
		<label class="screen-reader-text" for="excerpt"><?php
			_e( 'Excerpt' )
			?></label>
        <div>
            <a id="__MCH_HEAD_LINE_FLOAT__" class="button"><?php echo $floatStr ?></a>
        </div>
		<div id="__MCH_HEAD_LINE_LIST__">
		</div>
		<?php
	}

}

